package javax.management;

import java.security.AccessController;
import com.sun.jmx.mbeanserver.GetPropertyAction;
import java.io.ObjectOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.util.Date;
import java.io.ObjectStreamField;
import java.util.EventObject;

public class Notification extends EventObject
{
    private static final long oldSerialVersionUID = 1716977971058914352L;
    private static final long newSerialVersionUID = -7516092053498031989L;
    private static final ObjectStreamField[] oldSerialPersistentFields;
    private static final ObjectStreamField[] newSerialPersistentFields;
    private static final long serialVersionUID;
    private static final ObjectStreamField[] serialPersistentFields;
    private static boolean compat;
    private String type;
    private long sequenceNumber;
    private long timeStamp;
    private Object userData;
    private String message;
    protected Object source;
    
    public Notification(String type, Object o, long sequenceNumber) {
        super(o);
        this.userData = null;
        this.message = "";
        this.source = null;
        this.source = o;
        this.type = type;
        this.sequenceNumber = sequenceNumber;
        this.timeStamp = new Date().getTime();
    }
    
    public Notification(String type, Object o, long sequenceNumber, String message) {
        super(o);
        this.userData = null;
        this.message = "";
        this.source = null;
        this.source = o;
        this.type = type;
        this.sequenceNumber = sequenceNumber;
        this.timeStamp = new Date().getTime();
        this.message = message;
    }
    
    public Notification(String type, Object o, long sequenceNumber, long timeStamp) {
        super(o);
        this.userData = null;
        this.message = "";
        this.source = null;
        this.source = o;
        this.type = type;
        this.sequenceNumber = sequenceNumber;
        this.timeStamp = timeStamp;
    }
    
    public Notification(String type, Object o, long sequenceNumber, long timeStamp, String message) {
        super(o);
        this.userData = null;
        this.message = "";
        this.source = null;
        this.source = o;
        this.type = type;
        this.sequenceNumber = sequenceNumber;
        this.timeStamp = timeStamp;
        this.message = message;
    }
    
    public void setSource(Object o) {
        super.source = o;
        this.source = o;
    }
    
    public long getSequenceNumber() {
        return this.sequenceNumber;
    }
    
    public void setSequenceNumber(long sequenceNumber) {
        this.sequenceNumber = sequenceNumber;
    }
    
    public String getType() {
        return this.type;
    }
    
    public long getTimeStamp() {
        return this.timeStamp;
    }
    
    public void setTimeStamp(long timeStamp) {
        this.timeStamp = timeStamp;
    }
    
    public String getMessage() {
        return this.message;
    }
    
    public Object getUserData() {
        return this.userData;
    }
    
    public void setUserData(Object userData) {
        this.userData = userData;
    }
    
    @Override
    public String toString() {
        return super.toString() + "[type=" + this.type + "][message=" + this.message + "]";
    }
    
    private void readObject(ObjectInputStream objectInputStream) throws IOException, ClassNotFoundException {
        objectInputStream.defaultReadObject();
        super.source = this.source;
    }
    
    private void writeObject(ObjectOutputStream objectOutputStream) throws IOException {
        if (Notification.compat) {
            ObjectOutputStream.PutField putFields = objectOutputStream.putFields();
            putFields.put("type", this.type);
            putFields.put("sequenceNumber", this.sequenceNumber);
            putFields.put("timeStamp", this.timeStamp);
            putFields.put("userData", this.userData);
            putFields.put("message", this.message);
            putFields.put("source", this.source);
            objectOutputStream.writeFields();
        }
        else {
            objectOutputStream.defaultWriteObject();
        }
    }
    
    static {
        oldSerialPersistentFields = new ObjectStreamField[] { new ObjectStreamField("message", String.class), new ObjectStreamField("sequenceNumber", Long.TYPE), new ObjectStreamField("source", Object.class), new ObjectStreamField("sourceObjectName", ObjectName.class), new ObjectStreamField("timeStamp", Long.TYPE), new ObjectStreamField("type", String.class), new ObjectStreamField("userData", Object.class) };
        newSerialPersistentFields = new ObjectStreamField[] { new ObjectStreamField("message", String.class), new ObjectStreamField("sequenceNumber", Long.TYPE), new ObjectStreamField("source", Object.class), new ObjectStreamField("timeStamp", Long.TYPE), new ObjectStreamField("type", String.class), new ObjectStreamField("userData", Object.class) };
        Notification.compat = false;
        try {
            String s = (String)AccessController.doPrivileged(new GetPropertyAction("jmx.serial.form"));
            Notification.compat = (s != null && s.equals("1.0"));
        }
        catch (Exception ex) {}
        if (Notification.compat) {
            serialPersistentFields = Notification.oldSerialPersistentFields;
            serialVersionUID = 1716977971058914352L;
        }
        else {
            serialPersistentFields = Notification.newSerialPersistentFields;
            serialVersionUID = -7516092053498031989L;
        }
    }
}
